


/* *********************************************************
               Function declarations
  ********************************************************* */


void Initialize(void);
void feed(void);

void setup_uart0(int baud);
void setup_uart1(int baud, char want_ints);

void get_GPS_KML(void);
void get_GPS_NORMAL(void);
void GPS_init(void);

char getc(void);

void stat0_on (void);
void stat0_off (void);
void stat1_on (void);
void stat1_off (void);
void stat2_on (void);
void stat2_off (void);
void stat3_on (void);
void stat3_off (void);
void stat4_on (void);
void stat4_off (void);
void stat5_on (void);
void stat5_off (void);
void stat6_on (void);
void stat6_off (void);
void stat7_on (void);
void stat7_off (void);

void setmux_tsip(void);
void setmux_nmea(void);
void setmux_BT(void);
void setmux_cell(void);

void config_menu(void);
void put_char(char);
void putc2(char);
char getc2(void);



//void T0isr(void)	__irq;
void IRQ_Routine (void)   __attribute__ ((interrupt("IRQ")));
void FIQ_Routine (void)   __attribute__ ((interrupt("FIQ")));
void SWI_Routine (void)   __attribute__ ((interrupt("SWI")));
void UNDEF_Routine (void) __attribute__ ((interrupt("UNDEF")));

/**********************************************************
                  Header files
 **********************************************************/
#include "LPC21xx.h"
#include "fatLib.h"
#include "HALayer.h"
//#include "SFE_io.h"
//#include "stdlib.h"
//#include "cmath.h"


/**********************************************************
                  Global Variables
 **********************************************************/
char port = 0;
char RX_array[512];
char GPS_short[160];
char GPS_long[218];
char interval = 10;   //this is the alarm interval in minutes, default = 10
short RX_in = 0, RX_printed = 0;
float battery;
float temperature;
char mode;



/**********************************************************
                       MAIN
**********************************************************/
void __putchar(int ch)
{
  if (ch == '\n')
    put_char('\r');
  put_char(ch);
}

int	main (void)
{	
    int	j, k;
    
    int i;
    char q, f = 0;
    char temp;
    
    int y=0;
    char mon=0, d=0;
    char h=0, m1=0, m2 = 0, s=0;
    char a, b, c;

    signed int stringSize;
    signed char handle;
    char stringBuf[100];
    char title[10];
    
    Initialize();
    
    fat_initialize();   // Initialise the FAT library.

    

    for (i = 0; i < 5; i++)
    {
        stat0_on();
        for (j = 0; j < 120000; j++);
        stat0_off();
        stat1_on();
        for (j = 0; j < 120000; j++);
        stat1_off();
    }

    
    setup_uart0(9600);
    //printf("UART0 setup...\r\n",0);
    
    //printf("\r\nGPS Logger\r\n",0);

    GPS_init();
    
    //There needs to be some delay between setting up the uarts.  How much?
    //Don't know, but a printf clears it up just fine.
    
    setup_uart1(4800,0);
    //printf("UART1 setup...\r\n",0);
    
    /*
    handle = fat_openWrite("GPSlog.txt");
    if (handle >= 0)
    {
        strcpy(stringBuf, "Goodbye World!");
        stringSize = strlen(stringBuf);
        fat_write(handle,stringBuf, stringSize);
        fat_flush();    // Optional.
        fat_close(handle);
    }
    */

    while (1)
    {
        for (i = 0; i < 255; i++)
        {
            sprintf(title,"GPS%d.txt",i);
            handle = fat_openWrite(title);
            if (handle >= 0) break;
        }
        
                          
        if (handle >= 0)
        {
            while(1)
            {
                //strcpy(GPS_short, "Goodbye World!");
                if (mode == 1) get_GPS_KML();
                else if (mode == 0) get_GPS_NORMAL();
                stat0_off();
                stat1_off();
                stringSize = strlen(GPS_short);
                fat_write(handle,GPS_short, stringSize);
                fat_flush();    // Optional.
                
                
            }
        }
        
        
        /*
        if ((U0LSR & 0x01) != 0)	//if something comes in on port0...
        {
              stat0_on();
              //for (j = 0; j < 100000; j++ );
              //stat1_off();
              q = U0RBR;	//gotta read the RX buffer to set the flag back to 0
              
              if (q == 32)	//spacebar for set up
              {
                      config_menu();
                      //break;
              }
              
              //while((U1LSR & 0x40) != 0x40);	//bit 6 in U1LSR is TEMT
              //U1THR = q;
              stat0_off();
              
        }
        
        
        if ((U1LSR & 0x01) != 0)	//if something comes in on port1...
        {
              stat1_on();
              //for (j = 0; j < 500000; j++ );
              //stat1_off();
              q = U1RBR;	//gotta read the RX buffer to set the flag back to 0
              
              
              
              while((U0LSR & 0x40) != 0x40);	//bit 6 in U0LSR is TEMT
              U0THR = q;
              stat1_off();
              
        }
        */

       
    }
    
    
    

}



/**********************************************************
                      Initialize
**********************************************************/

#define PLOCK 0x400

void Initialize(void)
{
        short x;
	// Setting Multiplier and Divider values
  	PLLCFG=0x23;
  	feed();
  
	// Enabling the PLL */	
	PLLCON=0x1;
	feed();
  
	// Wait for the PLL to lock to set frequency
	while(!(PLLSTAT & PLOCK)) ;
  
	// Connect the PLL as the clock source
	PLLCON=0x3;
	feed();
  
	// Enabling MAM and setting number of clocks used for Flash memory fetch (4 cclks in this case)
	MAMCR=0x2;
	MAMTIM=0x4;
  
	// Setting peripheral Clock (pclk) to System Clock (cclk)
	VPBDIV=0x01;
	// Setting peripheral Clock (pclk) to System Clock (cclk)/2
	//VPBDIV=0x02;
	
        //PINSEL0 = 0x00000005;   // enable uart0
        //PINSEL0 = 0x00050005;   // enable uart0, enable uart1
	PINSEL0 = 0x00051505;	// enable uart0, enable uart1, enable SPI0 but with SSEL as IO
	//PINSEL1 = 0x10400001;	//AD0.0 and AD0.3 active
	
	//IODIR0 |= 0x007E3C80;	// SSEL is an out, a bunch of LED's as well, mux control = out
							// Don't have to set the directin of the UART pins after they're configured with PINSEL0
	//IODIR0 |= 0xC07BBC84;	//Next rev of the uber board, wiht nRF settings						
	IODIR0 |= 0x00000484;   //P0.26 is control line for lt1528 (cell supply, low active)

	//IOSET0  = 0x001E3C80;	// SSEL and the status LED's are low active, so set them high
	IOSET0 = 0x00000080;	//
	//IOCLR0 = 0x84200000;    //make sure P0.26 and P0.31 are low (cell and other peripheral supply)
	

  	//set up the SPI port
  	S0SPCCR = 0x08;			// set up SPI clk to be pclk/8, this is the fastest we can go
	S0SPCR = 0x30;			//master, msb first, first clk edge, active high, no ints
	
	//T0TCR 		= 0x00000002;			//Reset counter and prescaler
	//T0MCR 		= 0x00000003;			//On match reset the counter and generate an interrupt
	//T0MR0		= 0x002D0000;			//Set the cycle time, 50mS
	//T0PR 		= 0x00000000;
	//T0MR1		= 0x00000000;			// Set duty cycle to zero
	//T0EMR  		= 0x00000042;			//On match clear MAT1
	//T0TCR 		= 0x00000001;			//enable timer
	
	VICIntSelect = 0x00100000;			//BOD int
	
	VICIntEnable = 0x00100000;			//Enable the interrupt
        //EXTWAKE = 0x80;


}


void feed(void)
{
  PLLFEED=0xAA;
  PLLFEED=0x55;
}






/*  Stubs for various interrupts (may be replaced later)  */
/*  ----------------------------------------------------  */

void IRQ_Routine (void)
{
	while(1);
}



void FIQ_Routine (void)
{
	char a;
	int x;
        
        ILR = 3;
        
}


void SWI_Routine (void)  {
	while (1) ;	
}


void UNDEF_Routine (void) {
	
	stat0_on();
	//while (1) ;	
}

//Sends nate to the Transmit Register
void put_char(char c)
{
    if (port == 0)
    {
        while((U0LSR & 0x20) == 0);
        U0THR = c;
    }
    else if (port == 1)
    {
        while((U1LSR & 0x20) == 0);
        U1THR = c;
    }
}


//specific to UART0
char getc(void)
{
    while((U0LSR & 0x01) == 0);
    return (U0RBR);
}
   
char getc2(void)
{
    while((U1LSR & 0x01) == 0);
    return (U1RBR);
}


void putc2(char c)
{
    while((U1LSR & 0x20) == 0);
    U1THR = c;
}

void stat0_on (void)
{
	IOCLR0 = 0x00000004;

}

void stat0_off (void)
{
	IOSET0 = 0x00000004;
	
}

void stat1_on (void)
{
	IOCLR0 = 0x00000400;

}

void stat1_off (void)
{
	IOSET0 = 0x00000400;

}

void stat2_on (void)
{
	IOCLR0 = 0x00000800;

}

void stat2_off (void)
{
	IOSET0 = 0x00000800;

}

void stat3_on (void)
{
	IOCLR0 = 0x00001000;

}

void stat3_off (void)
{
	IOSET0 = 0x00001000;

}

void stat4_on (void)
{
	IOCLR0 = 0x00002000;
	
}

void stat4_off (void)
{
	IOSET0 = 0x00002000;

}

void stat5_on (void)
{
	IOCLR0 = 0x00008000;
	
}

void stat5_off (void)
{
	IOSET0 = 0x00008000;
	
}

void stat6_on (void)
{
	IOCLR0 = 0x00010000;
	
}

void stat6_off (void)
{
	IOSET0 = 0x00010000;

}

void stat7_on (void)
{
	IOCLR0 = 0x00020000;

}

void stat7_off (void)
{
	IOSET0 = 0x00020000;

}

void setmux_tsip(void)
{
	IOCLR0 = 0x00600000;
}

void setmux_nmea(void)
{
	IOCLR0 = 0x00400000;
	IOSET0 = 0x00200000;
}

void setmux_BT(void)
{
	IOCLR0 = 0x00200000;
	IOSET0 = 0x00400000;
}

void setmux_cell(void)
{
	//IOCLR0 = 0x00400000;
	IOSET0 = 0x00600000;
}

void setup_uart0(int baud)
{
	//set up uart0 
	U0LCR 	= 0x83;			// 8 bits, no Parity, 1 Stop bit, DLAB = 1
	
	if (baud == 1200)
	{
		U1DLM   = 0x0C;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	if (baud == 2400)
	{
		U1DLM   = 0x06;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
		
	if (baud == 4800)
	{
		U0DLM   = 0x03;		  	//
  		U0DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 9600)
	{
	 	U0DLM   = 0x01;		  	//
  		U0DLL 	= 0x80;        	// 9600 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 19200)
	{
	 	U0DLM   = 0x00;		  	//
  		U0DLL 	= 0xC0;        	// 19200 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 38400)
	{
	 	U0DLM   = 0x00;		  	//
  		U0DLL 	= 0x60;        	// 38400 Baud Rate @ 58982400 VPB Clock
	}
	                    
  	U0FCR	= 0x01;			// Not sure this is necessary, but the manual sez it is
	U0LCR 	= 0x03;        	// DLAB = 0
	
	//set up UART0 interupt
  	//VICIntSelect = 0x00000040;	//bit 6 is for UART0, sets to FIQ (not IRQ)
  	//VICIntEnable = 0x00000040;	//enables UART0 interupt
  	//VICVectCntl0 = 0x00000026;	//Set UART0 to slot 0 in the IRQ's
 	//U0IER = 0x01;				//enable RX data available interupt, DLAB must be 0 to write
}


void setup_uart1(int baud, char want_ints)
{
	//set up uart1
	U1LCR 	= 0x83;			// 8 bits, no Parity, 1 Stop bit, DLAB = 1
	
	if (baud == 1200)
	{
		U1DLM   = 0x0C;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	if (baud == 2400)
	{
		U1DLM   = 0x06;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	if (baud == 4800)
	{
		U1DLM   = 0x03;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 9600)
	{
	 	U1DLM   = 0x01;		  	//
  		U1DLL 	= 0x80;        	// 9600 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 19200)
	{
	 	U1DLM   = 0x00;		  	//
  		U1DLL 	= 0xC0;        	// 19200 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 38400)
	{
	 	U1DLM   = 0x00;		  	//
  		U1DLL 	= 0x60;        	// 38400 Baud Rate @ 58982400 VPB Clock
	}
	//U1IER = 0x01;					//enable RX data available interupt, DLAB must be 0 to write               
  	U1FCR	= 0x01;			// Not sure this is necessary, but the manual sez it is
  	
	U1LCR 	= 0x03;        	// DLAB = 0
	
	
	if (want_ints == 1)
	{
		VICIntSelect |= 0x00000080;		//bit 7 is for UART1, sets to FIQ (not IRQ)
		VICIntEnable |= 0x00000080;	//enables UART1 interupt
		U1IER = 0x01;					//enable RX data available interupt, DLAB must be 0 to write
		
	}
	
	else if (want_ints == 0)
	{
		VICIntEnClr = 0x00000080;	//disables UART1 interupt
		U1IER = 0x00;					//disable RX data available interupt, DLAB must be 0 to write
	}
	

	//U1LCR 	= 0x03;        	// DLAB = 0

	//set up UART1 interupt
  	//VICIntSelect |= 0x00000080;		//bit 7 is for UART1, sets to FIQ (not IRQ)
  	//VICIntEnable = 0x00000080;            //enables UART1 interupt
  	//VICVectCntl0 = 0x00000026;		//Set UART0 to slot 0 in the IRQ's
 	//U1IER = 0x01;                         //enable RX data available interupt, DLAB must be 0 to write
}

void config_menu(void)
{
	char a, q;
        char b = 'Q';
	char w, x, y, z;
	short i;
	int j;

	//stat0_on();

        //setup_uart1(4800,0);    //disable ints on UART1 while in cofig mode

	while (1)
	{
		printf("\r\nConfiguration setup, config mode\r\n",0);
		printf("========================================\r\n",0);
		//printf("1) Peripherals On\r\n",0);
		//printf("2) Peripherals Off\r\n",0);
		//printf("3) Power Down\r\n",0);
		//printf("4) Set the time and date\r\n",0);
		//printf("5) Set the alarm\r\n",0);
		//printf("6) Cell supply on\r\n",0);
                //printf("6) Get GPS frame\r\n",0);
                //printf("7) Get temp and Battery\r\n",0);
                printf("8) Run System\r\n",0);
		printf("9) Exit and run unit\r\n",0);
		//printf("  (Cannot run daily operations in config mode)\r\n",0);
		
		a = getc();
		
                /*
		if (a == '1')
		{
			IOSET0  = 0x80000000;
			printf("Done, peripheral supply on.\r\n",0);
		}
		
		else if (a == '2')
		{
			IOCLR0  = 0x80000000;
			printf("Done, peripheral supply off.\r\n",0);
			
		}
		
                
		else if (a == '3')
		{
                        setmux_BT();
                        //stat0_off();
                        IOCLR0 = 0x04000000;    //make sure P0.26 is low (lt1528 off)

			PCON = 0x02;    
                        
                        
                        //setup_uart0(9600);
                        Initialize();
                        //stat0_on();
                        put_char(b);
                        printf("This not is fucked\r\n",0);
			
		}
		
                                
		else if (a == '4')
		{
			CCR = 0;
			CCR = 16;		//Enable RTC config
			
			printf("\r\nEnter the year, 0000 to 4095: ",0);
			w = getc();
			put_char(w);
			x = getc();
			put_char(x);
			y = getc();
			put_char(y);
			z = getc();
			put_char(z);
			YEAR = (w-48)*1000 + (x-48)*100 + (y-48)*10 + z-48;
			
			printf("\r\nEnter the month, 00 to 12: ",0);
			x = getc();
			put_char(x);
			z = getc();
			put_char(z);
			MONTH = (x-48)*10 + z-48;
			
			printf("\r\nEnter the day of the month, 00 to 31: ",0);
			x = getc();
			put_char(x);
			z = getc();
			put_char(z);
			DOM = (x-48)*10 + z-48;
			
			printf("\r\nEnter hour, 00 to 23: ",0);
			x = getc();
			put_char(x);
			z = getc();
			put_char(z);
			HOUR = (x-48)*10 + z-48;
			
			printf("\r\nEnter minutes, 00 to 59: ",0);
			x = getc();
			put_char(x);
			z = getc();
			put_char(z);
			MIN = (x-48)*10 + z-48;
			
			printf("\r\nEnter seconds, 00 to 59: ",0);
			x = getc();
			put_char(x);
			z = getc();
			put_char(z);
			SEC = (x-48)*10 + z-48;
			
			CCR = 17;		//Run RTC
			
			ILR = 3;		//clear any clock ints pending
			
			put_char(10);
			put_char(13);
			
			
		}
				
		else if (a == '5')
		{
			CCR = 16;		//enable RTC config
			
			printf("\r\nEnter hour, 00 to 23: ",0);
			x = getc();
			put_char(x);
			z = getc();
			put_char(z);
			ALHOUR = (x-48)*10 + z-48;
			
			printf("\r\nEnter minutes, 00 to 59: ",0);
			x = getc();
			put_char(x);
			z = getc();
			put_char(z);
			ALMIN = (x-48)*10 + z-48;
			
			ALSEC = 0;		//Nobody wants to enter seconds for an alarm
			
			//AMR = 248;		//set alarm to read hours, minutes, seconds
                        AMR = 253;		//set alarm to read minutes only

			CCR = 17;		//Run RTC
			CIIR = 0x00;	//disable counter ints
			
			VICIntSelect = 0x00002000;
			VICIntEnable = 0x00002000;
			
			ILR = 3;	//Reset anything in here before enabling the int
			
		}	
		
		
		if (a == '6')
		{
                    stat0_off();
                    printf("Going for GPS...\r\n",0);
                    //get_GPS_frame();
                    get_GPS();
                    stat0_on();
		}
                
                
                else if (a == '7')
		{
                    get_temp();
		}
                */
                
                if (a == '8')
		{
                    signed int stringSize;
                    signed char handle;
                    char title[10];
                    
                    // Initialize the MCU
                    //Initialize();

                    //fat_initialize();   // Initialise the FAT library.
                    
                    for (w = 0; w < 255; w++)
                    {
                        sprintf(title,"GPS%d.txt",w);
                        handle = fat_openWrite(title);
                        if (handle >= 0) break;
                    }
                    
                                      
                    if (handle >= 0)
                    {
                        while(1)
                        {
                            //strcpy(GPS_short, "Goodbye World!");
                            if (mode == 1) get_GPS_KML();
                            else if (mode == 0) get_GPS_NORMAL();
                            stat0_off();
                            stat1_off();
                            stringSize = strlen(GPS_short);
                            fat_write(handle,GPS_short, stringSize);
                            fat_flush();    // Optional.
                            
                            if ((U0LSR & 0x01) != 0)	//if something comes in on port0...
                            {
                                  q = U0RBR;	//gotta read the RX buffer to set the flag back to 0
                                  
                                  break;
                            }
                        }
                        fat_close(handle);
                        printf("\r\nStopped.\r\n",0);

                    }
                    
                    
                    
                    /*
                    handle = fat_openRead("EMcon.txt");
                    if (handle >= 0)
                    {
                        stringSize = fat_read(handle, stringBuf, 512);
                        stringBuf[stringSize] = '\0';
                        printf(stringBuf);
                        fat_close(handle);
                    }
                    */

                    else printf(" \r\nNope.\r\n",0);

		}
                
                /*
                else if (a == '8')
		{
                    run_sys();
                    printf("\r\nDone.\r\n",0);

		}
		*/

		if (a == '9')
		{
			printf("Exiting...\r\n",0);
			printf("Hit the spacebar to enter the configuration menu\r\n",0);
			break;
			
		}
				
		//else aprintf("Invalid entry.  Try again.\r\n",0);
		
	}
        
        // RX_in = 0;
        //RX_printed = 0;
        //setup_uart1(4800,1);    //set UART1 back to ints and zero the indeces when leaving config mode

        stat0_off();
}

void get_GPS_KML(void)
{
    float q = 0, r = 0, s = 0;
    int x, y, z;
    char temp;
    char temp2[7];
    char north = 0, west = 0;
    char lat[10], lon[11], alt[5];
    char mark1 = 0, mark2 = 0;

    for (x = 0; x < 160; x++)    //zero the arrays
    {
        GPS_short[x] = 0;

        if (x < 11)
        {
            lon[x] = 0;
        }

        if (x < 10)
        {
            lat[x] = 0;
        }

        if (x < 5) alt[x] = 0;
    }
    
    //GPS_short[0] = 10;
    //GPS_short[1] = 13;
    //setup_uart1(4800,0); 
    
    U1FCR = 0x02;

    while(1)
    {
        //stat0_on();
        temp = getc2();
        //stat0_off();
        
        //put_char(temp);

        if (temp == '$')
        {
            //

            temp = getc2();
            temp = getc2();
            temp = getc2();

            if (temp == 'G')
            {
                //stat1_on();
                temp = getc2();
                temp = getc2();
                temp = getc2();
                temp = getc2();

                if (temp != ',')
                {
                    stat0_on();
                    temp = 0;
                    //while (temp != ',')
                    //{
                        //temp = getc2();
                    //}

                    y = 0;
                    x = 0;

                    while (x < 9)
                    {
                        temp = getc2();

                        if (temp == ',')
                        {
                            x++;
                            y = 0;
                            temp = getc2();
                        }
                        
                        
                        if (x == 1)
                        {
                            lat[y] = temp;
                            if (temp == '.') mark1 = y;
                            y++;

                        }
                        
                        
                        if (x == 2)
                        {
                            if (temp == 'S')
                            {
                                mark1++;
                                for (z = 9; z > 0; z--)
                                {
                                    lat[z] = lat[z-1];
                                }
                                lat[0] = '-';
                            }
                            y++;
                        }

                        if (x == 3)
                        {
                            lon[y] = temp;
                            if (temp == '.') mark2 = y;
                            y++;
                        }
                        
                        
                        if (x == 4)
                        {
                            if (temp == 'W')
                            {
                                mark2++;
                                for (z = 10; z > 0; z--)
                                {
                                    lon[z] = lon[z-1];
                                }
                                lon[0] = '-';
                            }
                            y++;
                        }
                        
                        
                        if (x == 8)
                        {
                            alt[y] = temp;
                            y++;
                        }
                        

                    }

                    break;
                }
            }
        }
    }
    
    
    /*
    put_char(10);
    put_char(13);

    for (x = 0; x < 40; x++)
    {
        put_char(GPS_short[x]);
    }
    */

    //put_char(10);
    //put_char(13);

    for (x = 0; x < 7; x++)
    {
        temp2[x] = lat[mark1 - 2 + x];
        lat[mark1 - 2 + x] = 0;
    }
    
    //q = atof(lat)/60;
    //q += atof(temp2);
    q = atof(temp2)/60;
    r = atof(lat);

    if (r < 0) r -= q;
    else r += q;
    //printf("\r\nq = %3.13f\r\n",q);
    //printf("\r\nr = %3.13f\r\n",r);
    //printf("\r\nlat = %3.13f\r\n",r);


    for (x = 0; x < 7; x++)
    {
        temp2[x] = lon[mark2 - 2 + x];
        lon[mark2 - 2 + x] = 0;
    }
    
    //q = atof(lon)/60;
    //q += atof(temp2);
    q = atof(temp2)/60;
    s = atof(lon);

    if (s < 0) s -= q;
    else s += q;
    //printf("\r\nq = %3.13f\r\n",q);
    //printf("\r\nr = %3.13f\r\n",r);
    //printf("\r\nlon = %3.13f\r\n",s);

    x = atoi(alt);

    sprintf(GPS_short,"%3.13f,%3.13f,%d \r\n",s,r,x);
    
    //for (x = 0; x < 50; x++)
    //{
        //put_char(GPS_short[x]);
    //}

    /*
    //put_char(10);
    //put_char(13);
    
    
    for (x = 0; x < 11; x++)
    {
        if (lon[x] != 0) put_char(lon[x]);
    }
    
    //put_char(10);
    //put_char(13);
    
    
    for (x = 0; x < 5; x++)
    {
        if (alt[x] != 0) put_char(alt[x]);
    }
    
    put_char(10);
    put_char(13);
    */
}


void GPS_init(void)
{
    int j, x, mark = 0, index = 0;
    char temp;
    signed int stringSize;
    signed char handle;
    char stringBuf[100];

    handle = fat_openRead("GPScon.txt");
    if (handle >= 0)
    {
        stringSize = fat_read(handle, stringBuf, 512);
        stringBuf[stringSize] = '\0';
        //printf(stringBuf);
        fat_close(handle);
    }

    else
    {
        handle = fat_openWrite("GPScon.txt");
        if (handle >= 0)
        {
            strcpy(stringBuf, "MODE = NORMAL\r\n");
            stringSize = strlen(stringBuf);
            fat_write(handle,stringBuf, stringSize);
            
            /*
            strcpy(stringBuf, "LOG = ALL\r\n");
            stringSize = strlen(stringBuf);
            fat_write(handle,stringBuf, stringSize);
            */

            fat_flush();    // Optional.
            fat_close(handle);
        }

        else if (handle < 0)
        {
            while(1)    //in case there's no card or it's full...
            {
                stat0_on();
                for (j = 0; j < 120000; j++);
                stat0_off();
                stat1_on();
                for (j = 0; j < 120000; j++);
                stat1_off();
            }
        }
    }
    
    for (x = 0; x < stringSize; x++)
    {
        temp = stringBuf[x];
        if (temp == 10)
        {
            mark = x;
            index++;
        }

        if (index == 1)
        {
            //put_char(stringBuf[mark - 4]);
            if (stringBuf[mark - 3] == 'A') mode = 0;
            else if (stringBuf[mark - 3] == 'M') mode = 1;
        }
    }
    
    printf("\r\nMode = %d\r\n",mode);


}


void get_GPS_NORMAL(void)
{
    int x;
    char temp, mark = 0;

    

    for (x = 0; x < 160; x++)    //zero the array
    {
        GPS_short[x] = 0;

    }
    
    U1FCR = 0x02;   //clear the RX FIFO

    while(1)
    {
        //stat0_on();
        temp = getc2();
        //stat0_off();
        
        //put_char(temp);

        if (temp == '$')
        {
            stat1_on();
            GPS_short[0] = temp;

            for (x = 1; x < 160; x++)
            {
                GPS_short[x] = getc2();
                if (GPS_short[x] == 10) mark++;
                if (mark == 2) return;
            }
        }
    }


}


